Index: /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1025)
@@ -2157,10 +2292,14 @@
                       if ((domain->type) != CDomain::type_attr::unstructured)
                       {
-                        start.push_back(nZoomBeginServer[idx] - nZoomBeginGlobal[idx]);
-                        count.push_back(nZoomSizeServer[idx]);
+                        // start.push_back(nZoomBeginServer[idx] - nZoomBeginGlobal[idx]);
+                        // count.push_back(nZoomSizeServer[idx]);
+                        start.push_back((domain->getStartWriteIndex())[idx]);
+                        count.push_back((domain->getCountWriteIndex())[idx]);
                       }
                       --idx ;
-                      start.push_back(nZoomBeginServer[idx] - nZoomBeginGlobal[idx]);
-                      count.push_back(nZoomSizeServer[idx]);
+                      // start.push_back(nZoomBeginServer[idx] - nZoomBeginGlobal[idx]);
+                      // count.push_back(nZoomSizeServer[idx]);
+                      start.push_back((domain->getStartWriteIndex())[idx]);
+                      count.push_back((domain->getCountWriteIndex())[idx]);
                       --idx ;
                       --idxDomain;
@@ -2168,7 +2307,9 @@
                     else if (1 == axisDomainOrder(i))
                     {
-                      start.push_back(nZoomBeginServer[idx] - nZoomBeginGlobal[idx]);
-                      count.push_back(nZoomSizeServer[idx]);
+                      CAxis* axis = CAxis::get(axisList[idxAxis]);
+                      start.push_back(axis->getStartWriteIndex());
+                      count.push_back(axis->getCountWriteIndex());
                       --idx;
+                      --idxAxis;
                     }
                     else
Index: /XIOS/dev/dev_olga/src/node/axis.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1024)
+++ /XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1025)
@@ -131,4 +131,38 @@
    }
 
+   /*!
+     Returns the start of indexes written by each server.
+     \return the start of indexes written by each server
+   */
+   int CAxis::getStartWriteIndex() const
+   {
+     return start_write_index_;
+   }
+
+   /*!
+     Returns the count of indexes written by each server.
+     \return the count of indexes written by each server
+   */
+   int CAxis::getCountWriteIndex() const
+   {
+     return count_write_index_;
+   }
+
+   /*!
+     Returns the local data written by each server.     
+   */
+   int CAxis::getLocalWriteSize() const
+   {
+     return local_write_size_;
+   }
+
+   /*!
+     Returns the global data written by all server.     
+   */
+   int CAxis::getGlobalWriteSize() const
+   {
+     return global_write_size_;
+   }
+
    //----------------------------------------------------------------
 
@@ -166,5 +200,5 @@
      {
        // size estimation for sendDistributedValue
-       std::map<int, std::vector<size_t> >::const_iterator it, ite = indSrv_.end();
+       boost::unordered_map<int, vector<size_t> >::const_iterator it, ite = indSrv_.end();
        for (it = indSrv_.begin(); it != ite; ++it)
        {
@@ -292,4 +326,8 @@
      if (global_zoom_begin.isEmpty()) global_zoom_begin.setValue(0);
      if (global_zoom_n.isEmpty()) global_zoom_n.setValue(n_glo.getValue());
+     if (zoom_index.isEmpty())
+     {
+       zoom_index.setValue(index.getValue());
+     }
    }
 
@@ -342,18 +380,18 @@
         switch(event.type)
         {
-           case EVENT_ID_SERVER_ATTRIBUT :
-             recvServerAttribut(event);
-             return true;
-             break;
-           case EVENT_ID_INDEX:
-            recvIndex(event);
+           // case EVENT_ID_SERVER_ATTRIBUT :
+           //   recvServerAttribut(event);
+           //   return true;
+           //   break;
+          //  case EVENT_ID_INDEX:
+          //   recvIndex(event);
+          //   return true;
+          //   break;
+          case EVENT_ID_NON_DISTRIBUTED_ATTRIBUTES:
+            recvNonDistributedAttributes(event);
             return true;
             break;
-          case EVENT_ID_DISTRIBUTED_VALUE:
-            recvDistributedValue(event);
-            return true;
-            break;
-          case EVENT_ID_NON_DISTRIBUTED_VALUE:
-            recvNonDistributedValue(event);
+          case EVENT_ID_DISTRIBUTED_ATTRIBUTES:
+            recvDistributedAttributes(event);
             return true;
             break;
@@ -383,5 +421,5 @@
      if (context->hasClient)
      {
-       if (n.getValue() != n_glo.getValue()) computeConnectedServer(globalDim, orderPositionInGrid, distType);
+       if (index.numElements() != n_glo.getValue()) computeConnectedServer(globalDim, orderPositionInGrid, distType);
      }
 
@@ -398,19 +436,15 @@
 
      if (this->isChecked) return;
-     if (context->hasClient)
-     {
-       sendServerAttribut(globalDim, orderPositionInGrid, distType);
-       if (hasValue) sendValue();
-     }
+     if (context->hasClient) sendAttributes();    
 
      this->isChecked = true;
    }
 
-  void CAxis::sendValue()
-  {
-     if (n.getValue() == n_glo.getValue())
-       sendNonDistributedValue();
+  void CAxis::sendAttributes()
+  {
+     if (index.numElements() == n_glo.getValue())
+       sendNonDistributedAttributes();
      else
-       sendDistributedValue();
+       sendDistributedAttributes();
   }
 
@@ -419,51 +453,52 @@
   {
     CContext* context = CContext::getCurrent();
-    CContextClient* client = context->client;
+    CContextClient* client = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
     int nbServer = client->serverSize;
     int range, clientSize = client->clientSize;
     int rank = client->clientRank;
 
-    size_t ni = this->n.getValue();
-    size_t ibegin = this->begin.getValue();
-    size_t zoom_end = global_zoom_begin+global_zoom_n-1;
-    size_t nZoomCount = 0;
+    // size_t ni = this->n.getValue();
+    // size_t ibegin = this->begin.getValue();
+    // size_t zoom_end = global_zoom_begin+global_zoom_n-1;
+    // size_t nZoomCount = 0;
     size_t nbIndex = index.numElements();
     for (size_t idx = 0; idx < nbIndex; ++idx)
     {
-      size_t globalIndex = index(idx);
-      if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nZoomCount;
-    }
-
-    CArray<size_t,1> globalIndexAxis(nbIndex);
-    std::vector<size_t> globalAxisZoom(nZoomCount);
-    nZoomCount = 0;
-    for (size_t idx = 0; idx < nbIndex; ++idx)
-    {
-      size_t globalIndex = index(idx);
-      globalIndexAxis(idx) = globalIndex;
-      if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end)
-      {
-        globalAxisZoom[nZoomCount] = globalIndex;
-        ++nZoomCount;
-      }
-    }
-
-    std::set<int> writtenInd;
-    if (isCompressible_)
-    {
-      for (int idx = 0; idx < data_index.numElements(); ++idx)
-      {
-        int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, ni);
-
-        if (ind >= 0 && ind < ni && mask(ind))
-        {
-          ind += ibegin;
-          if (ind >= global_zoom_begin && ind <= zoom_end)
-            writtenInd.insert(ind);
-        }
-      }
-    }
-
-    CServerDistributionDescription serverDescriptionGlobal(globalDim, nbServer);
+      globalLocalIndexMap_[index(idx)] = idx;
+      // size_t globalIndex = index(idx);
+      // if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nZoomCount;
+    }
+
+    // CArray<size_t,1> globalIndexAxis(nbIndex);
+    // std::vector<size_t> globalAxisZoom(nZoomCount);
+    // nZoomCount = 0;
+    // for (size_t idx = 0; idx < nbIndex; ++idx)
+    // {
+    //   size_t globalIndex = index(idx);
+    //   globalIndexAxis(idx) = globalIndex;
+    //   if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end)
+    //   {
+    //     globalAxisZoom[nZoomCount] = globalIndex;
+    //     ++nZoomCount;
+    //   }
+    // }
+
+    // std::set<int> writtenInd;
+    // if (isCompressible_)
+    // {
+    //   for (int idx = 0; idx < data_index.numElements(); ++idx)
+    //   {
+    //     int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, ni);
+
+    //     if (ind >= 0 && ind < ni && mask(ind))
+    //     {
+    //       ind += ibegin;
+    //       if (ind >= global_zoom_begin && ind <= zoom_end)
+    //         writtenInd.insert(ind);
+    //     }
+    //   }
+    // }
+
+    CServerDistributionDescription serverDescriptionGlobal(globalDim, nbServer, distType);
     int distributedDimensionOnServer = serverDescriptionGlobal.getDimensionDistributed();
     CClientServerMapping::GlobalIndexMap globalIndexAxisOnServer;
@@ -493,8 +528,12 @@
       }
 
+      CArray<size_t,1> globalIndex(index.numElements());
+      for (size_t idx = 0; idx < globalIndex.numElements(); ++idx)
+        globalIndex(idx) = index(idx);
+
       CServerDistributionDescription serverDescription(nGlobAxis, nbServer);
       serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t,size_t>(indexBegin, indexEnd));
       CClientServerMapping* clientServerMap = new CClientServerMappingDistributed(serverDescription.getGlobalIndexRange(), client->intraComm);
-      clientServerMap->computeServerIndexMapping(globalIndexAxis);
+      clientServerMap->computeServerIndexMapping(globalIndex);
       globalIndexAxisOnServer = clientServerMap->getGlobalIndexOnServer();
       delete clientServerMap;
@@ -514,110 +553,221 @@
     }
 
-    CClientServerMapping::GlobalIndexMap::const_iterator it = globalIndexAxisOnServer.begin(),
-                                                         ite = globalIndexAxisOnServer.end();
-    std::vector<size_t>::const_iterator itbVec = (globalAxisZoom).begin(),
-                                        iteVec = (globalAxisZoom).end();
-    indSrv_.clear();
-    indWrittenSrv_.clear();
-    for (; it != ite; ++it)
-    {
-      int rank = it->first;
-      const std::vector<size_t>& globalIndexTmp = it->second;
-      int nb = globalIndexTmp.size();
-
-      for (int i = 0; i < nb; ++i)
-      {
-        if (std::binary_search(itbVec, iteVec, globalIndexTmp[i]))
-        {
-          indSrv_[rank].push_back(globalIndexTmp[i]);
-        }
-
-        if (writtenInd.count(globalIndexTmp[i]))
-        {
-          indWrittenSrv_[rank].push_back(globalIndexTmp[i]);
-        }
-      }
-    }
+    indSrv_.swap(globalIndexAxisOnServer);
+
+    // CClientServerMapping::GlobalIndexMap::const_iterator it = globalIndexAxisOnServer.begin(),
+    //                                                      ite = globalIndexAxisOnServer.end();
+    CClientServerMapping::GlobalIndexMap::const_iterator it = indSrv_.begin(),
+                                                         ite = indSrv_.end();
+    // std::vector<size_t>::const_iterator itbVec = (globalAxisZoom).begin(),
+    //                                     iteVec = (globalAxisZoom).end();
+    // indSrv_.clear();
+    // indWrittenSrv_.clear();
+    // for (; it != ite; ++it)
+    // {
+    //   int rank = it->first;
+    //   const std::vector<size_t>& globalIndexTmp = it->second;
+    //   int nb = globalIndexTmp.size();
+
+    //   for (int i = 0; i < nb; ++i)
+    //   {
+    //     if (std::binary_search(itbVec, iteVec, globalIndexTmp[i]))
+    //     {
+    //       indSrv_[rank].push_back(globalIndexTmp[i]);
+    //     }
+
+    //     if (writtenInd.count(globalIndexTmp[i]))
+    //     {
+    //       indWrittenSrv_[rank].push_back(globalIndexTmp[i]);
+    //     }
+    //   }
+    // }
 
     connectedServerRank_.clear();
-    for (it = globalIndexAxisOnServer.begin(); it != ite; ++it) {
+    for (it = indSrv_.begin(); it != ite; ++it) {
       connectedServerRank_.push_back(it->first);
     }
 
-    if (!indSrv_.empty())
-    {
-      std::map<int, vector<size_t> >::const_iterator itIndSrv  = indSrv_.begin(),
-                                                     iteIndSrv = indSrv_.end();
-      connectedServerRank_.clear();
-      for (; itIndSrv != iteIndSrv; ++itIndSrv)
-        connectedServerRank_.push_back(itIndSrv->first);
-    }
+    // if (!indSrv_.empty())
+    // {
+    //   std::map<int, vector<size_t> >::const_iterator itIndSrv  = indSrv_.begin(),
+    //                                                  iteIndSrv = indSrv_.end();
+    //   connectedServerRank_.clear();
+    //   for (; itIndSrv != iteIndSrv; ++itIndSrv)
+    //     connectedServerRank_.push_back(itIndSrv->first);
+    // }
     nbConnectedClients_ = CClientServerMapping::computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, connectedServerRank_);
   }
 
-  void CAxis::sendNonDistributedValue()
+
+  // void CAxis::computeConnectedServer(const std::vector<int>& globalDim, int orderPositionInGrid,
+  //                                    CServerDistributionDescription::ServerDistributionType distType)
+  // {
+  //   CContext* context = CContext::getCurrent();
+  //   CContextClient* client = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+  //   int nbServer = client->serverSize;
+  //   int range, clientSize = client->clientSize;
+  //   int rank = client->clientRank;
+
+  //   size_t ni = this->n.getValue();
+  //   size_t ibegin = this->begin.getValue();
+  //   size_t zoom_end = global_zoom_begin+global_zoom_n-1;
+  //   size_t nZoomCount = 0;
+  //   size_t nbIndex = index.numElements();
+  //   for (size_t idx = 0; idx < nbIndex; ++idx)
+  //   {
+  //     size_t globalIndex = index(idx);
+  //     if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nZoomCount;
+  //   }
+
+  //   CArray<size_t,1> globalIndexAxis(nbIndex);
+  //   std::vector<size_t> globalAxisZoom(nZoomCount);
+  //   nZoomCount = 0;
+  //   for (size_t idx = 0; idx < nbIndex; ++idx)
+  //   {
+  //     size_t globalIndex = index(idx);
+  //     globalIndexAxis(idx) = globalIndex;
+  //     if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end)
+  //     {
+  //       globalAxisZoom[nZoomCount] = globalIndex;
+  //       ++nZoomCount;
+  //     }
+  //   }
+
+  //   std::set<int> writtenInd;
+  //   if (isCompressible_)
+  //   {
+  //     for (int idx = 0; idx < data_index.numElements(); ++idx)
+  //     {
+  //       int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, ni);
+
+  //       if (ind >= 0 && ind < ni && mask(ind))
+  //       {
+  //         ind += ibegin;
+  //         if (ind >= global_zoom_begin && ind <= zoom_end)
+  //           writtenInd.insert(ind);
+  //       }
+  //     }
+  //   }
+
+  //   CServerDistributionDescription serverDescriptionGlobal(globalDim, nbServer);
+  //   int distributedDimensionOnServer = serverDescriptionGlobal.getDimensionDistributed();
+  //   CClientServerMapping::GlobalIndexMap globalIndexAxisOnServer;
+  //   if (distributedDimensionOnServer == orderPositionInGrid) // So we have distributed axis on client side and also on server side*
+  //   {
+  //     std::vector<int> nGlobAxis(1);
+  //     nGlobAxis[0] = n_glo.getValue();
+
+  //     size_t globalSizeIndex = 1, indexBegin, indexEnd;
+  //     for (int i = 0; i < nGlobAxis.size(); ++i) globalSizeIndex *= nGlobAxis[i];
+  //     indexBegin = 0;
+  //     if (globalSizeIndex <= clientSize)
+  //     {
+  //       indexBegin = rank%globalSizeIndex;
+  //       indexEnd = indexBegin;
+  //     }
+  //     else
+  //     {
+  //       for (int i = 0; i < clientSize; ++i)
+  //       {
+  //         range = globalSizeIndex / clientSize;
+  //         if (i < (globalSizeIndex%clientSize)) ++range;
+  //         if (i == client->clientRank) break;
+  //         indexBegin += range;
+  //       }
+  //       indexEnd = indexBegin + range - 1;
+  //     }
+
+  //     CServerDistributionDescription serverDescription(nGlobAxis, nbServer);
+  //     serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t,size_t>(indexBegin, indexEnd));
+  //     CClientServerMapping* clientServerMap = new CClientServerMappingDistributed(serverDescription.getGlobalIndexRange(), client->intraComm);
+  //     clientServerMap->computeServerIndexMapping(globalIndexAxis);
+  //     globalIndexAxisOnServer = clientServerMap->getGlobalIndexOnServer();
+  //     delete clientServerMap;
+  //   }
+  //   else
+  //   {
+  //     std::vector<size_t> globalIndexServer(n_glo.getValue());
+  //     for (size_t idx = 0; idx < n_glo.getValue(); ++idx)
+  //     {
+  //       globalIndexServer[idx] = idx;
+  //     }
+
+  //     for (int idx = 0; idx < nbServer; ++idx)
+  //     {
+  //       globalIndexAxisOnServer[idx] = globalIndexServer;
+  //     }
+  //   }
+
+  //   CClientServerMapping::GlobalIndexMap::const_iterator it = globalIndexAxisOnServer.begin(),
+  //                                                        ite = globalIndexAxisOnServer.end();
+  //   std::vector<size_t>::const_iterator itbVec = (globalAxisZoom).begin(),
+  //                                       iteVec = (globalAxisZoom).end();
+  //   indSrv_.clear();
+  //   indWrittenSrv_.clear();
+  //   for (; it != ite; ++it)
+  //   {
+  //     int rank = it->first;
+  //     const std::vector<size_t>& globalIndexTmp = it->second;
+  //     int nb = globalIndexTmp.size();
+
+  //     for (int i = 0; i < nb; ++i)
+  //     {
+  //       if (std::binary_search(itbVec, iteVec, globalIndexTmp[i]))
+  //       {
+  //         indSrv_[rank].push_back(globalIndexTmp[i]);
+  //       }
+
+  //       if (writtenInd.count(globalIndexTmp[i]))
+  //       {
+  //         indWrittenSrv_[rank].push_back(globalIndexTmp[i]);
+  //       }
+  //     }
+  //   }
+
+  //   connectedServerRank_.clear();
+  //   for (it = globalIndexAxisOnServer.begin(); it != ite; ++it) {
+  //     connectedServerRank_.push_back(it->first);
+  //   }
+
+  //   if (!indSrv_.empty())
+  //   {
+  //     std::map<int, vector<size_t> >::const_iterator itIndSrv  = indSrv_.begin(),
+  //                                                    iteIndSrv = indSrv_.end();
+  //     connectedServerRank_.clear();
+  //     for (; itIndSrv != iteIndSrv; ++itIndSrv)
+  //       connectedServerRank_.push_back(itIndSrv->first);
+  //   }
+  //   nbConnectedClients_ = CClientServerMapping::computeConnectedClients(client->serverSize, client->clientSize, client->intraComm, connectedServerRank_);
+  // }
+
+  void CAxis::sendNonDistributedAttributes()
   {
     CContext* context = CContext::getCurrent();
-    CContextClient* client = context->client;
-    CEventClient event(getType(), EVENT_ID_NON_DISTRIBUTED_VALUE);
-
-    int zoom_end = global_zoom_begin + global_zoom_n - 1;
-    int nb = 0;
-    for (size_t idx = 0; idx < n; ++idx)
-    {
-      size_t globalIndex = begin + idx;
-      if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end) ++nb;
-    }
-
-    int nbWritten = 0;
-    if (isCompressible_)
-    {
-      for (int idx = 0; idx < data_index.numElements(); ++idx)
-      {
-        int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, n);
-
-        if (ind >= 0 && ind < n && mask(ind))
-        {
-          ind += begin;
-          if (ind >= global_zoom_begin && ind <= zoom_end)
-            ++nbWritten;
-        }
-      }
-    }
-
-    CArray<double,1> val(nb);
-    nb = 0;
-    for (size_t idx = 0; idx < n; ++idx)
-    {
-      size_t globalIndex = begin + idx;
-      if (globalIndex >= global_zoom_begin && globalIndex <= zoom_end)
-      {
-        val(nb) = value(idx);
-        ++nb;
-      }
-    }
-
-    CArray<int, 1> writtenInd(nbWritten);
-    nbWritten = 0;
-    if (isCompressible_)
-    {
-      for (int idx = 0; idx < data_index.numElements(); ++idx)
-      {
-        int ind = CDistributionClient::getAxisIndex(data_index(idx), data_begin, n);
-
-        if (ind >= 0 && ind < n && mask(ind))
-        {
-          ind += begin;
-          if (ind >= global_zoom_begin && ind <= zoom_end)
-          {
-            writtenInd(nbWritten) = ind;
-            ++nbWritten;
-          }
-        }
-      }
+    CContextClient* client = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+    
+    CEventClient event(getType(), EVENT_ID_NON_DISTRIBUTED_ATTRIBUTES);
+    size_t nbIndex = index.numElements();
+    size_t nbDataIndex = 0;
+
+    for (int idx = 0; idx < data_index.numElements(); ++idx)
+    {      
+      int ind = data_index(idx);
+      if (ind >= 0 && ind < nbIndex) ++nbDataIndex;
+    }
+
+    CArray<int,1> dataIndex(nbDataIndex);
+    nbDataIndex = 0;
+    for (int idx = 0; idx < data_index.numElements(); ++idx)
+    {      
+      int ind = data_index(idx);
+      if (ind >= 0 && ind < nbIndex)
+      {
+        dataIndex(nbDataIndex) = ind;
+        ++nbDataIndex;
+      } 
     }
 
     if (client->isServerLeader())
-    {
+    { 
       std::list<CMessage> msgs;
 
@@ -628,7 +778,11 @@
         CMessage& msg = msgs.back();
         msg << this->getId();
-        msg << val;
-        if (isCompressible_)
-          msg << writtenInd;
+        msg << index.getValue() << dataIndex << zoom_index.getValue() << mask.getValue();
+        msg << hasValue;
+        if (hasValue) msg << value.getValue();
+
+        msg << hasBounds_;
+        if (hasBounds_) msg << bounds.getValue();
+        
         event.push(*itRank, 1, msg);
       }
@@ -638,21 +792,77 @@
   }
 
-  void CAxis::sendDistributedValue(void)
+  void CAxis::recvNonDistributedAttributes(CEventServer& event)
+  {
+    list<CEventServer::SSubEvent>::iterator it;
+    for (it = event.subEvents.begin(); it != event.subEvents.end(); ++it)
+    {
+      CBufferIn* buffer = it->buffer;
+      string axisId;
+      *buffer >> axisId;
+      get(axisId)->recvNonDistributedAttributes(it->rank, *buffer);
+    }
+  }
+
+  void CAxis::recvNonDistributedAttributes(int rank, CBufferIn& buffer)
+  { 
+    CArray<int,1> tmp_index, tmp_data_index, tmp_zoom_index;
+    CArray<bool,1> tmp_mask;
+    CArray<double,1> tmp_val;
+    CArray<double,2> tmp_bnds;
+
+    buffer >> tmp_index;
+    index.reference(tmp_index);
+    buffer >> tmp_data_index;
+    data_index.reference(tmp_data_index);
+    buffer >> tmp_zoom_index;
+    zoom_index.reference(tmp_zoom_index);
+    buffer >> tmp_mask;
+    mask.reference(tmp_mask);
+    buffer >> hasValue;
+    if (hasValue)
+    {
+      buffer >> tmp_val;
+      value.reference(tmp_val);
+    }
+
+    buffer >> hasBounds_;
+    if (hasBounds_)
+    {
+      buffer >> tmp_bnds;
+      bounds.reference(tmp_bnds);
+    }
+
+    {      
+      count_write_index_ = zoom_index.numElements();            
+      start_write_index_ = 0;
+      local_write_size_ = count_write_index_;
+      global_write_size_ = count_write_index_;
+    }
+  }
+
+  void CAxis::sendDistributedAttributes(void)
   {
     int ns, n, i, j, ind, nv, idx;
     CContext* context = CContext::getCurrent();
-    CContextClient* client=context->client;
-
-    // send value for each connected server
-    CEventClient eventIndex(getType(), EVENT_ID_INDEX);
-    CEventClient eventVal(getType(), EVENT_ID_DISTRIBUTED_VALUE);
-
-    list<CMessage> list_msgsIndex, list_msgsVal;
-    list<CArray<int,1> > list_indi;
-    list<CArray<int,1> > list_writtenInd;
+    CContextClient* client = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+
+    CEventClient eventData(getType(), EVENT_ID_DISTRIBUTED_ATTRIBUTES);
+    
+    list<CMessage> listData;
+    list<CArray<int,1> > list_indi, list_dataInd, list_zoomInd;    
+    list<CArray<bool,1> > list_mask;
     list<CArray<double,1> > list_val;
     list<CArray<double,2> > list_bounds;
 
-    std::map<int, std::vector<size_t> >::const_iterator it, iteMap;
+    int nbIndex = index.numElements();
+    CArray<int,1> dataIndex(nbIndex);
+    dataIndex = -1;
+    for (int idx = 0; idx < data_index.numElements(); ++idx)
+    {
+      if (0 <= data_index(idx) && data_index(idx) < nbIndex)
+        dataIndex(idx) = data_index(idx);
+    }
+
+    boost::unordered_map<int, std::vector<size_t> >::const_iterator it, iteMap;
     iteMap = indSrv_.end();
     for (int k = 0; k < connectedServerRank_.size(); ++k)
@@ -660,4 +870,5 @@
       int nbData = 0;
       int rank = connectedServerRank_[k];
+      int nbSendingClient = nbConnectedClients_[rank];
       it = indSrv_.find(rank);
       if (iteMap != it)
@@ -665,5 +876,11 @@
 
       list_indi.push_back(CArray<int,1>(nbData));
-      list_val.push_back(CArray<double,1>(nbData));
+      list_dataInd.push_back(CArray<int,1>(nbData));
+      list_zoomInd.push_back(CArray<int,1>(nbData));
+      list_mask.push_back(CArray<bool,1>(nbData));
+
+
+      if (hasValue)
+        list_val.push_back(CArray<double,1>(nbData));
 
       if (hasBounds_)
@@ -673,13 +890,23 @@
 
       CArray<int,1>& indi = list_indi.back();
-      CArray<double,1>& val = list_val.back();
+      CArray<int,1>& dataIndi = list_dataInd.back();
+      CArray<int,1>& zoomIndi = list_zoomInd.back();
+      CArray<bool,1>& maskIndi = list_mask.back();      
 
       for (n = 0; n < nbData; ++n)
       {
         idx = static_cast<int>(it->second[n]);
-        ind = idx - begin;
-
-        val(n) = value(ind);
         indi(n) = idx;
+
+        ind = globalLocalIndexMap_[idx];
+        dataIndi(n) = dataIndex(ind);
+        maskIndi(n) = mask(ind);
+        zoomIndi(n) = zoom_index(ind);        
+
+        if (hasValue)
+        {
+          CArray<double,1>& val = list_val.back();
+          val(n) = value(ind);
+        }
 
         if (hasBounds_)
